function [amps] = getAmplitude(x,y,ac,apodization,theta,fc,c0,focusDepth)

W = zeros(1,length(x));
x0 = 0;
x_focus = cos(theta)*focusDepth;
y_focus = sin(theta)*focusDepth;
for i = 1:length(ac)
    y0 = ac(i);
    delay = -sqrt((y_focus-y0)^2 + (x_focus-x0)^2); %scalar
    d = sqrt( (x-x0).^2 + (y-y0).^2 ); % vector of length(x)
    W = W + apodization(i)*exp(j*(d+delay)*fc/c0);
end
amps = abs(W);
