% function VerifyLinearDelayAndSumOpt()

load data128ch40b512x4s

beams = length(theta);
channels = length(ac);

gpu_data = quarterTEXF( dataUp, ac, fs, c0, theta);

ref_data = zeros(size(dataUp,1),beams);
for b = 1:beams
    ref_data(:,b) = beamform(dataUp(:,(1+(b-1)*channels):(b*channels))', 4*fs, ac, theta(b), c0);
end

quarter_ref_data = ref_data(1:4:end,:);


normalized_max_deviation = max(max(abs( quarter_ref_data - gpu_data )))/max(max(gpu_data))