

load data128ch40b512x4s

beams = length(theta);
channels = length(ac);

no_mla = 3;
o = (theta(2)-theta(1))/no_mla;
theta = [theta-o;theta;theta+o];

gpu_data = quarterTEXF_MLA( dataUp, ac, fs, c0, theta);

%%

ref_data = zeros(size(dataUp,1),no_mla*beams);
for b = 1:beams
    for mla = 1:no_mla
        ref_data(:,(b-1)*no_mla + mla) = beamform(dataUp(:,(1+(b-1)*channels):(b*channels))', 4*fs, ac, theta(mla,b), c0);
    end
end

quarter_ref_data = ref_data(1:4:end,:);


normalized_max_deviation = max(max(abs( quarter_ref_data - gpu_data )))/max(max(gpu_data))