
load data128ch40b512s

beams = length(theta);
channels = length(ac);

gpu_data = TEXF( data, ac, fs, c0, theta);
%%

ref_data = zeros(size(gpu_data));
for b = 1:beams
    ref_data(:,b) = beamform(data(:,(1+(b-1)*channels):(b*channels))', fs, ac, theta(b), c0);
end

normalized_max_deviation = max(max(abs( ref_data - gpu_data )))/max(max(gpu_data))