
load data128ch40b512s

beams = length(theta);
channels = length(ac);

apo = createApo(size(data,1), channels, 0.1, 1);

gpu_data = TEXF_APO( data, ac, fs, c0, theta, apo);
%%

ref_data = zeros(size(gpu_data));
for b = 1:beams
    ref_data(:,b) = beamformApo(data(:,(1+(b-1)*channels):(b*channels))', apo, fs, ac, theta(b), c0);
end

normalized_max_deviation = max(max(abs( ref_data - gpu_data )))/max(max(gpu_data))