

load data128ch40b512s

beams = length(theta);
channels = length(ac);

no_mla = 3;
o = (theta(2)-theta(1))/no_mla;
theta = [theta-o;theta;theta+o];


gpu_data = TEXF_MLA( data, ac, fs, c0, theta);




ref_data = zeros(size(data,1),no_mla*beams);
for b = 1:beams
    for mla = 1:no_mla
        ref_data(:,(b-1)*no_mla + mla) = beamform(data(:,(1+(b-1)*channels):(b*channels))', fs, ac, theta(mla,b), c0);
    end
end


normalized_max_deviation = max(max(abs( ref_data - gpu_data )))/max(max(gpu_data))