function [apo] = createApo(samples, channels, startW, endW)

apo = zeros(samples,channels);

W = linspace(startW, endW, samples);
for i = 1:samples
    apo(i,:) = interp1(linspace(-W(i),W(i),channels),hann(channels),linspace(-1,1,channels),'spline',0);
end