block_size = 128; % defined in TEXF.cu

load ac;
fs = 40e6;
c0 = 1560;

beams =32;
samples = 768*2;

t = zeros(length(ac),1);

channels = 1:length(ac);
for i = 1:length(ac)
    [dummy, t(i)] = TEXF(zeros(samples,length(ac)*beams), ones(size(ac))*ac(i),fs,c0, zeros(beams,1));
end
%%

plot(channels, t,'b');
xlabel('Channels')
ylabel('Performance(samples/second)')
set(gca,'xtick',0:32:128)
grid on