#line 1 "TEXF_MLA.cudafe2.gpu"


#line 4 "TEXF_MLA.cudafe2.gpu"

#line 432 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"
typedef unsigned size_t;
#line 434 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"
#line 1 "C:\\CUDA\\include\\crt/device_runtime.h"








































#line 42 "C:\\CUDA\\include\\crt/device_runtime.h"

#line 1 "c:\\cuda\\include\\crt\\../host_defines.h"










































#line 44 "c:\\cuda\\include\\crt\\../host_defines.h"


































#line 79 "c:\\cuda\\include\\crt\\../host_defines.h"













#line 93 "c:\\cuda\\include\\crt\\../host_defines.h"














#line 108 "c:\\cuda\\include\\crt\\../host_defines.h"
#line 44 "C:\\CUDA\\include\\crt/device_runtime.h"
#line 1 "c:\\cuda\\include\\crt\\storage_class.h"










































































#line 76 "c:\\cuda\\include\\crt\\storage_class.h"
#line 45 "C:\\CUDA\\include\\crt/device_runtime.h"








typedef const void* __i1texture;

typedef const void* __i2texture;

typedef const void* __i3texture;

typedef const void* __u1texture;

typedef const void* __u2texture;

typedef const void* __u3texture;

typedef const void* __f1texture;

typedef const void* __f2texture;

typedef const void* __f3texture;






#line 77 "C:\\CUDA\\include\\crt/device_runtime.h"




#line 82 "C:\\CUDA\\include\\crt/device_runtime.h"






















































































#line 169 "C:\\CUDA\\include\\crt/device_runtime.h"

#line 1 "c:\\cuda\\include\\crt\\../builtin_types.h"









































#line 1 "c:\\cuda\\include\\device_types.h"













































enum cudaRoundMode
{
  cudaRoundNearest,
  cudaRoundZero,
  cudaRoundPosInf,
  cudaRoundMinInf
};

#line 55 "c:\\cuda\\include\\device_types.h"
#line 43 "c:\\cuda\\include\\crt\\../builtin_types.h"
#line 1 "c:\\cuda\\include\\driver_types.h"

















































#line 52 "c:\\cuda\\include\\driver_types.h"








enum cudaError
{
  cudaSuccess = 0,
  cudaErrorMissingConfiguration,
  cudaErrorMemoryAllocation,
  cudaErrorInitializationError,
  cudaErrorLaunchFailure,
  cudaErrorPriorLaunchFailure,
  cudaErrorLaunchTimeout,
  cudaErrorLaunchOutOfResources,
  cudaErrorInvalidDeviceFunction,
  cudaErrorInvalidConfiguration,
  cudaErrorInvalidDevice,
  cudaErrorInvalidValue,
  cudaErrorInvalidPitchValue,
  cudaErrorInvalidSymbol,
  cudaErrorMapBufferObjectFailed,
  cudaErrorUnmapBufferObjectFailed,
  cudaErrorInvalidHostPointer,
  cudaErrorInvalidDevicePointer,
  cudaErrorInvalidTexture,
  cudaErrorInvalidTextureBinding,
  cudaErrorInvalidChannelDescriptor,
  cudaErrorInvalidMemcpyDirection,
  cudaErrorAddressOfConstant,
  cudaErrorTextureFetchFailed,
  cudaErrorTextureNotBound,
  cudaErrorSynchronizationError,
  cudaErrorInvalidFilterSetting,
  cudaErrorInvalidNormSetting,
  cudaErrorMixedDeviceExecution,
  cudaErrorCudartUnloading,
  cudaErrorUnknown,
  cudaErrorNotYetImplemented,
  cudaErrorMemoryValueTooLarge,
  cudaErrorInvalidResourceHandle,
  cudaErrorNotReady,
  cudaErrorStartupFailure = 0x7f,
  cudaErrorApiFailureBase = 10000
};


enum cudaMemcpyKind
{
  cudaMemcpyHostToHost = 0,
  cudaMemcpyHostToDevice,
  cudaMemcpyDeviceToHost,
  cudaMemcpyDeviceToDevice
};


struct cudaDeviceProp
{
  char   name[256];
  size_t totalGlobalMem;
  size_t sharedMemPerBlock;
  int    regsPerBlock;
  int    warpSize;
  size_t memPitch;
  int    maxThreadsPerBlock;
  int    maxThreadsDim[3];
  int    maxGridSize[3]; 
  size_t totalConstMem; 
  int    major;
  int    minor;
  int    clockRate;
  size_t textureAlignment;
};


























typedef enum cudaError cudaError_t;


typedef int cudaStream_t;


typedef int cudaEvent_t;

#line 163 "c:\\cuda\\include\\driver_types.h"
#line 44 "c:\\cuda\\include\\crt\\../builtin_types.h"
#line 1 "c:\\cuda\\include\\texture_types.h"













































struct cudaArray;


enum cudaChannelFormatKind
{
  cudaChannelFormatKindSigned,
  cudaChannelFormatKindUnsigned,
  cudaChannelFormatKindFloat
};


struct cudaChannelFormatDesc
{
  int                        x;
  int                        y;
  int                        z;
  int                        w;
  enum cudaChannelFormatKind f;
};


enum cudaTextureAddressMode
{
  cudaAddressModeWrap,
  cudaAddressModeClamp
};


enum cudaTextureFilterMode
{
  cudaFilterModePoint,
  cudaFilterModeLinear
};


enum cudaTextureReadMode
{
  cudaReadModeElementType,
  cudaReadModeNormalizedFloat
};


struct textureReference
{
  int                           normalized;
  enum cudaTextureFilterMode    filterMode;
  enum cudaTextureAddressMode   addressMode[2];
  struct cudaChannelFormatDesc  channelDesc;
};














































#line 142 "c:\\cuda\\include\\texture_types.h"

#line 144 "c:\\cuda\\include\\texture_types.h"
#line 45 "c:\\cuda\\include\\crt\\../builtin_types.h"
#line 1 "c:\\cuda\\include\\vector_types.h"












































#line 1 "c:\\cuda\\include\\host_defines.h"










































































































#line 108 "c:\\cuda\\include\\host_defines.h"
#line 46 "c:\\cuda\\include\\vector_types.h"








struct char1
{
  signed char x;
};


struct uchar1 
{
  unsigned char x;
};


struct __attribute__((aligned(2))) char2
{
  signed char x, y;
};


struct __attribute__((aligned(2))) uchar2
{
  unsigned char x, y;
};


struct char3
{
  signed char x, y, z;
};


struct uchar3
{
  unsigned char x, y, z;
};


struct __attribute__((aligned(4))) char4
{
  signed char x, y, z, w;
};


struct __attribute__((aligned(4))) uchar4
{
  unsigned char x, y, z, w;
};


struct short1
{
  short x;
};


struct ushort1
{
  unsigned short x;
};


struct __attribute__((aligned(4))) short2
{
  short x, y;
};


struct __attribute__((aligned(4))) ushort2
{
  unsigned short x, y;
};


struct short3
{
  short x, y, z;
};


struct ushort3
{
  unsigned short x, y, z;
};


struct __attribute__((aligned(8))) short4
{
  short x, y, z, w;
};


struct __attribute__((aligned(8))) ushort4
{
  unsigned short x, y, z, w;
};


struct int1
{
  int x;
};


struct uint1
{
  unsigned int x;
};


struct __attribute__((aligned(8))) int2
{
  int x, y;
};


struct __attribute__((aligned(8))) uint2
{
  unsigned int x, y;
};


struct int3
{
  int x, y, z;
};


struct uint3
{
  unsigned int x, y, z;
};


struct __attribute__((aligned(16))) int4
{
  int x, y, z, w;
};


struct __attribute__((aligned(16))) uint4
{
  unsigned int x, y, z, w;
};


struct long1
{
  long x;
};


struct ulong1
{
  unsigned long x;
};


struct __attribute__((aligned(8))) long2
{
  long x, y;
};


struct __attribute__((aligned(8))) ulong2
{
  unsigned long x, y;
};


struct long3
{
  long x, y, z;
};


struct ulong3
{
  unsigned long x, y, z;
};


struct __attribute__((aligned(16))) long4
{
  long x, y, z, w;
};


struct __attribute__((aligned(16))) ulong4
{
  unsigned long x, y, z, w;
};


struct float1
{
  float x;
};


struct __attribute__((aligned(8))) float2
{
  float x, y;
};


struct float3
{
  float x, y, z;
};


struct __attribute__((aligned(16))) float4
{
  float x, y, z, w;
};


struct __attribute__((aligned(16))) double2
{
  double x, y;
};








typedef struct char1 char1;

typedef struct uchar1 uchar1;

typedef struct char2 char2;

typedef struct uchar2 uchar2;

typedef struct char3 char3;

typedef struct uchar3 uchar3;

typedef struct char4 char4;

typedef struct uchar4 uchar4;

typedef struct short1 short1;

typedef struct ushort1 ushort1;

typedef struct short2 short2;

typedef struct ushort2 ushort2;

typedef struct short3 short3;

typedef struct ushort3 ushort3;

typedef struct short4 short4;

typedef struct ushort4 ushort4;

typedef struct int1 int1;

typedef struct uint1 uint1;

typedef struct int2 int2;

typedef struct uint2 uint2;

typedef struct int3 int3;

typedef struct uint3 uint3;

typedef struct int4 int4;

typedef struct uint4 uint4;

typedef struct long1 long1;

typedef struct ulong1 ulong1;

typedef struct long2 long2;

typedef struct ulong2 ulong2;

typedef struct long3 long3;

typedef struct ulong3 ulong3;

typedef struct long4 long4;

typedef struct ulong4 ulong4;

typedef struct float1 float1;

typedef struct float2 float2;

typedef struct float3 float3;

typedef struct float4 float4;

typedef struct double2 double2;








typedef struct dim3 dim3;


struct dim3
{
    unsigned int x, y, z;




#line 374 "c:\\cuda\\include\\vector_types.h"
};

#line 377 "c:\\cuda\\include\\vector_types.h"
#line 46 "c:\\cuda\\include\\crt\\../builtin_types.h"
#line 171 "C:\\CUDA\\include\\crt/device_runtime.h"
#line 1 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"






































#line 1 "c:\\cuda\\include\\vector_types.h"























































































































































































































































































































































































#line 377 "c:\\cuda\\include\\vector_types.h"
#line 40 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"



#line 44 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"






#line 51 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"


uint3 extern const threadIdx;

uint3 extern const blockIdx;

dim3 extern const blockDim;

dim3 extern const gridDim;





#line 66 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"

#line 68 "c:\\cuda\\include\\crt\\../device_launch_parameters.h"
#line 172 "C:\\CUDA\\include\\crt/device_runtime.h"
#line 435 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"

#line 437 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"

#line 439 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"



#line 443 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"



#line 447 "C:\\Program Files\\Microsoft Visual Studio 8\\VC\\INCLUDE\\crtdefs.h"
#line 1256 "c:\\cuda\\include\\texture_fetch_functions.h"
static __inline__ float _Z5tex2DIL19cudaTextureReadMode1EEf7textureIfLi2EXT_EEff(__f2texture, float, float);
#line 20 "TEXF_MLA.cu"
__attribute__((__global__)) extern void _Z20delay_and_sum_kernelPf(float *const);
#line 14 "TEXF_MLA.cu"
static __attribute__((__texture__)) __f2texture tex;
#line 16 "TEXF_MLA.cu"
static __attribute__((__constant__)) float C1_gpu[128];
#line 17 "TEXF_MLA.cu"
static __attribute__((__constant__)) float C3_gpu[128];
#line 18 "TEXF_MLA.cu"
static __attribute__((__constant__)) float C4_gpu[40][4];
#line 1 "C:\\CUDA\\include\\common_functions.h"





























































#line 63 "C:\\CUDA\\include\\common_functions.h"

#line 1 "c:\\cuda\\include\\crt/func_macro.h"



























































#line 61 "c:\\cuda\\include\\crt/func_macro.h"

#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 65 "C:\\CUDA\\include\\common_functions.h"

static long __cuda_clock(void)
{
  return clock();
}

static void *__cuda_memset(void *s, int c, size_t n)
{
  char *p = (char*)s;
  
  while (n--) *p++ = (char)c;

  return s;
}

#line 81 "C:\\CUDA\\include\\common_functions.h"







#line 1 "c:\\cuda\\include\\math_functions.h"














































































































































































































































































































































































































































































































































































































































































































































































































#line 784 "c:\\cuda\\include\\math_functions.h"

#line 1 "c:\\cuda\\include\\crt/func_macro.h"





























































#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 786 "c:\\cuda\\include\\math_functions.h"








static int __cuda___signbitl(long double a);
static int __cuda___isinfl(long double a);
static int __cuda___isnanl(long double a);
static int __cuda___finitel(long double a);

#line 800 "c:\\cuda\\include\\math_functions.h"
































#line 833 "c:\\cuda\\include\\math_functions.h"

static int __cuda_abs(int a)
{
  return abs(a);
}

static float __cuda_fabsf(float a)
{
  return fabsf(a);
}

static long long int __cuda_llabs(long long int a)
{


#line 849 "c:\\cuda\\include\\math_functions.h"
  return llabs(a);
#line 851 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_exp2f(float a)
{
  return exp2f(a);
}

#line 1 "c:\\cuda\\include\\device_functions.h"




























































































































































































































































































































#line 318 "c:\\cuda\\include\\device_functions.h"

#line 1 "c:\\cuda\\include\\crt/func_macro.h"





























































#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 320 "c:\\cuda\\include\\device_functions.h"

#line 1 "c:\\cuda\\include\\host_defines.h"










































































































#line 108 "c:\\cuda\\include\\host_defines.h"
#line 322 "c:\\cuda\\include\\device_functions.h"
#line 1 "c:\\cuda\\include\\math_constants.h"





































































































#line 103 "c:\\cuda\\include\\math_constants.h"
#line 323 "c:\\cuda\\include\\device_functions.h"

































































































































































































































































































































































































































































































































































































































































































































































































































#line 1125 "c:\\cuda\\include\\device_functions.h"

static float __fdividef(float a, float b)
{
  return a / b;
}

#line 1132 "c:\\cuda\\include\\device_functions.h"







static float __sinf(float a)
{
  return sinf(a);
}

static float __cosf(float a)
{
  return cosf(a);
}

static float __log2f(float a)
{
  return log2f(a);
}







static float __internal_accurate_fdividef(float a, float b)
{
  if (__cuda_fabsf(b) > 8.507059173e37f) {
    a *= .25f;
    b *= .25f;
  }
  return __fdividef(a, b);
}

static float __tanf(float a)
{
  return __sinf(a) / __cosf(a);
}

static void __sincosf(float a, float *sptr, float *cptr)
{
  *sptr = __sinf(a);
  *cptr = __cosf(a);
}

static float __expf(float a)
{
  return __cuda_exp2f(a * 1.442695041f);
}

static float __exp10f(float a)
{
  return __cuda_exp2f(a * 3.321928094f);
}

static float __log10f(float a)
{
  return 0.301029996f * __log2f(a);
}

static float __logf(float a)
{
  return 0.693147181f * __log2f(a);
}

static float __powf(float a, float b)
{
  return __cuda_exp2f(b * __log2f(a));
}

static float fdividef(float a, float b)
{


#line 1210 "c:\\cuda\\include\\device_functions.h"
  return __internal_accurate_fdividef(a, b);
#line 1212 "c:\\cuda\\include\\device_functions.h"
}

static int __clz(int a)
{
  return (a)?(158-(__float_as_int(__uint2float_rz((unsigned int)a))>>23)):32;
}

static int __ffs(int a)
{
  return 32 - __clz (a & -a);
}

static int __clzll(long long int a)
{
  int ahi = ((int)(a >> 32));
  int alo = ((int)(a & 0xffffffffULL));
  int res;
  if (ahi) {
      res = 0;
  } else {
      res = 32;
      ahi = alo;
  }
  res = res + __clz(ahi);
  return res;
}

static int __ffsll(long long int a)
{
  return 64 - __clzll (a & -a);
}





#line 1249 "c:\\cuda\\include\\device_functions.h"



static double fdivide(double a, double b)
{
  return (double)fdividef((float)a, (float)b);
}























#line 1280 "c:\\cuda\\include\\device_functions.h"

#line 1282 "c:\\cuda\\include\\device_functions.h"

#line 1284 "c:\\cuda\\include\\device_functions.h"







#line 1 "c:\\cuda\\include\\sm_11_atomic_functions.h"















































































































































































































#line 209 "c:\\cuda\\include\\sm_11_atomic_functions.h"

#line 1 "c:\\cuda\\include\\crt/func_macro.h"





























































#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 211 "c:\\cuda\\include\\sm_11_atomic_functions.h"














































































































































































#line 386 "c:\\cuda\\include\\sm_11_atomic_functions.h"

#line 388 "c:\\cuda\\include\\sm_11_atomic_functions.h"

#line 390 "c:\\cuda\\include\\sm_11_atomic_functions.h"
#line 1292 "c:\\cuda\\include\\device_functions.h"
#line 1 "c:\\cuda\\include\\texture_fetch_functions.h"






















































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































































#line 1976 "c:\\cuda\\include\\texture_fetch_functions.h"

#line 1 "c:\\cuda\\include\\host_defines.h"










































































































#line 108 "c:\\cuda\\include\\host_defines.h"
#line 1978 "c:\\cuda\\include\\texture_fetch_functions.h"
#line 1 "c:\\cuda\\include\\crt/func_macro.h"





























































#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 1979 "c:\\cuda\\include\\texture_fetch_functions.h"



extern  uint4 __utexfetchi1D(__i1texture, int4);
extern   int4 __itexfetchi1D(__i2texture, int4);
extern float4 __ftexfetchi1D(__i3texture, int4);
extern  uint4 __utexfetch1D(__u1texture, float4);
extern   int4 __itexfetch1D(__u2texture, float4);
extern float4 __ftexfetch1D(__u3texture, float4);
extern  uint4 __utexfetch2D(__f1texture, float4);
extern   int4 __itexfetch2D(__f2texture, float4);
extern float4 __ftexfetch2D(__f3texture, float4);








































































#line 2064 "c:\\cuda\\include\\texture_fetch_functions.h"

#line 2066 "c:\\cuda\\include\\texture_fetch_functions.h"

#line 2068 "c:\\cuda\\include\\texture_fetch_functions.h"

#line 1293 "c:\\cuda\\include\\device_functions.h"

#line 1295 "c:\\cuda\\include\\device_functions.h"

#line 859 "c:\\cuda\\include\\math_functions.h"
#line 1 "c:\\cuda\\include\\math_constants.h"





































































































#line 103 "c:\\cuda\\include\\math_constants.h"
#line 860 "c:\\cuda\\include\\math_functions.h"

static int __cuda___signbitf(float a)
{
  return (int)((unsigned int)__float_as_int(a) >> 31);
}




static float __cuda_copysignf(float a, float b)
{
  return __int_as_float((__float_as_int(b) &  0x80000000) | 
                        (__float_as_int(a) & ~0x80000000));
}













































































































































































#line 1048 "c:\\cuda\\include\\math_functions.h"







static long int __cuda_labs(long int a)
{
  return labs(a);
}

static float __cuda_ceilf(float a)
{
  return ceilf(a);
}

static float __cuda_floorf(float a)
{
  return floorf(a);
}

static float __cuda_sqrtf(float a)
{
   return sqrtf(a);
}

static float __cuda_rsqrtf(float a)
{
   return 1.0f / sqrtf(a);
}

static float __cuda_truncf(float a)
{
  return truncf(a);
}

static int __cuda_max(int a, int b)
{
  return max(a, b);
}

static int __cuda_min(int a, int b)
{
  return min(a, b);
}

static unsigned int __cuda_umax(unsigned int a, unsigned int b)
{
  return umax(a, b);
}

static unsigned int __cuda_umin(unsigned int a, unsigned int b)
{
  return umin(a, b);
}

static long long int __cuda_llrintf(float a)
{
  return __float2ll_rn(a);
}

static long int __cuda_lrintf(float a)
{


#line 1115 "c:\\cuda\\include\\math_functions.h"
  return (long int)__float2int_rn(a);
#line 1117 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_nearbyintf(float a)
{

  return roundf(a);


#line 1126 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_fmaxf(float a, float b)
{

  return fmaxf(a, b);


#line 1135 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_fminf(float a, float b)
{

  return fminf(a, b);


#line 1144 "c:\\cuda\\include\\math_functions.h"
}

















static int __cuda___finitef(float a)
{
  return __cuda_fabsf(a) < __int_as_float(0x7f800000);
}

static int __cuda___isinff(float a)
{
  return __cuda_fabsf(a) == __int_as_float(0x7f800000);
}

static int __cuda___isnanf(float a)
{
  return !(__cuda_fabsf(a) <= __int_as_float(0x7f800000));
}

static float __cuda_nextafterf(float a, float b)
{
  unsigned int ia;
  unsigned int ib;
  ia = __float_as_int(a);
  ib = __float_as_int(b);

  if ((ia << 1) < 0x01000000) ia &= 0x80000000; 
  if ((ib << 1) < 0x01000000) ib &= 0x80000000; 
#line 1187 "c:\\cuda\\include\\math_functions.h"
  if (__cuda___isnanf(a) || __cuda___isnanf(b)) return a + b; 
  if (__int_as_float (ia | ib) == 0.0f) return b;

  if (__int_as_float(ia) == 0.0f) {
    return __cuda_copysignf(1.175494351e-38f, b); 
  }




#line 1198 "c:\\cuda\\include\\math_functions.h"
  if ((a < b) && (a < 0.0f)) ia--;
  if ((a < b) && (a > 0.0f)) ia++;
  if ((a > b) && (a < 0.0f)) ia++;
  if ((a > b) && (a > 0.0f)) ia--;
  a = __int_as_float(ia);

  if (__cuda_fabsf(a) < 1.175494351e-38f) {
    a = __int_as_float(ia & 0x80000000); 
  }
#line 1208 "c:\\cuda\\include\\math_functions.h"
  return a;
}

static float __cuda_nanf(const char *tagp)
{
  
  return __int_as_float(0x7fffffff);
}


static float __internal_atanhf_kernel(float a_1, float a_2)
{
  float a, a2, t;

  a = a_1 + a_2;
  a2 = a * a;    
  t =          1.566305595598990E-001f/64.0f;
  t = t * a2 + 1.995081856004762E-001f/16.0f;
  t = t * a2 + 3.333382699617026E-001f/4.0f;
  t = t * a2;
  t = t * a + a_2;
  t = t + a_1;
  return t;
}  




static float __internal_atanf_kernel(float a)
{
  float t4, t0, t1;

  t4 = a * a;
  t0 =         - 5.674867153f;
  t0 = t4 *    - 0.823362947f + t0;
  t0 = t0 * t4 - 6.565555096f;
  t0 = t0 * t4;
  t0 = t0 * a;
  t1 = t4      + 11.33538818f;
  t1 = t1 * t4 + 28.84246826f;
  t1 = t1 * t4 + 19.69667053f;
  t1 = 1.0f / t1;
  a = t0 * t1 + a;
  return a;
}


static float __internal_tan_kernel(float a)
{
  float a2, s, t;

  a2 = a * a;
  t  = 4.114678393115178E-003f * a2 - 8.231194034909670E-001f;
  s  = a2 - 2.469348886157666E+000f;
  s  = 1.0f / s;
  t  = t * s;
  t  = t * a2;
  t  = t * a + a;
  return t;
}

static float __internal_accurate_logf(float a)
{
  float t;
  float z;
  float m;
  int ia, e;
  ia = __float_as_int(a);
  
  if ((ia < 0x00800000) || (ia > 0x7f7fffff)) {
    return __logf(a);
  }
  
  m = __int_as_float((ia & 0x807fffff) | 0x3f800000);
  e = ((unsigned)ia >> 23) - 127;
  if (m > 1.414213562f) {
    m = m * 0.5f;
    e = e + 1;
  }      
  t = m - 1.0f;
  z = m + 1.0f;
  z = t / z;
  z = -t * z;
  z = __internal_atanhf_kernel(t, z);
  z = (float)e * 0.693147181f + z;
  return z;
}  

static float __internal_accurate_log2f(float a)
{
  return 1.442695041f * __internal_accurate_logf(a);
}


static __attribute__((__constant__)) unsigned int __cudart_i2opi_f [] = {
  0x3c439041,
  0xdb629599,
  0xf534ddc0,
  0xfc2757d1,
  0x4e441529,
  0xa2f9836e,
};


static float __internal_trig_reduction_kernel(float a, int *quadrant)
{
  float j;
  int q;
  if (__cuda_fabsf(a) > 48039.0f) {
    
    unsigned int ia = __float_as_int(a);
    unsigned int s = ia & 0x80000000;
    unsigned int result[7];
    unsigned int phi, plo;
    unsigned int hi, lo;
    unsigned int e;
    int idx;
    e = ((ia >> 23) & 0xff) - 128;
    ia = (ia << 8) | 0x80000000;
    
    idx = 4 - (e >> 5);
    hi = 0;

#pragma unroll 1
#line 1333 "c:\\cuda\\include\\math_functions.h"
    for (q = 0; q < 6; q++) {
      plo = __cudart_i2opi_f[q] * ia;
      phi = __umulhi (__cudart_i2opi_f[q], ia);
      lo = hi + plo;
      hi = phi + (lo < plo);
      result[q] = lo;
    }
    result[q] = hi;
    e = e & 31;
    


    hi = result[idx+2];
    lo = result[idx+1];
    if (e) {
      q = 32 - e;
      hi = (hi << e) | (lo >> q);
      lo = (lo << e) | (result[idx] >> q);
    }
    q = hi >> 30;
    
    hi = (hi << 2) | (lo >> 30);
    lo = (lo << 2);
    e = (hi + (lo > 0)) > 0x80000000; 
    q += e;
    if (s) q = -q;
    if (e) {
      unsigned int t;
      hi = ~hi;
      lo = -(int)lo;
      t = (lo == 0);
      hi += t;
      s = s ^ 0x80000000;
    }
    *quadrant = q;
    
    e = 0;
    while ((int)hi > 0) {
      hi = (hi << 1) | (lo >> 31);
      lo = (lo << 1);
      e--;
    }
    lo = hi * 0xc90fdaa2;
    hi = __umulhi(hi, 0xc90fdaa2);
    if ((int)hi > 0) {
      hi = (hi << 1) | (lo >> 31);
      lo = (lo << 1);
      e--;
    }
    hi = hi + (lo > 0);
    ia = s | (((e + 126) << 23) + (hi >> 8) + ((hi << 24) >= 0x80000000));
    return __int_as_float(ia);
  }
  q = __float2int_rn(a * 0.636619772f);
  j = (float)q;
  a = a - j * 1.5703125000000000e+000f;
  a = a - j * 4.8351287841796875e-004f;
  a = a - j * 3.1385570764541626e-007f;
  a = a - j * 6.0771005065061922e-011f;
  *quadrant = q;
  return a;
}










static float __internal_expf_kernel(float a, float scale)
{
  float j, z;

  j = __cuda_truncf(a * 1.442695041f);
  z = a - j * 0.6931457519f;
  z = z - j * 1.4286067653e-6f;
  z = z * 1.442695041f;
  z = __cuda_exp2f(z) * __cuda_exp2f(j + scale);
  return z;
}

static float __internal_accurate_expf(float a)
{
  float z;
  z = __internal_expf_kernel(a, 0.0f);
  if (a < -105.0f) z = 0.0f;
  if (a >  105.0f) z = __int_as_float(0x7f800000);
  return z;
}

static float __internal_accurate_exp10f(float a)
{
  float j, z;
  j = __cuda_truncf(a * 3.321928094f);
  z = a - j * 3.0102920532226563e-001f;
  z = z - j * 7.9034171557301747e-007f;
  z = z * 3.321928094f;
  z = __cuda_exp2f(z) * __cuda_exp2f(j);
  if (a < -46.0f) z = 0.0f;
  if (a >  46.0f) z = __int_as_float(0x7f800000);
  return z;
}

static float __internal_lgammaf_pos(float a)
{
  float sum;
  float s, t;

  if (__cuda___isinff(a)) {
    return a;
  }
  if (a >= 3.0f) {
    if (a >= 7.8f) {
      


      s = 1.0f / a;
      t = s * s;
      sum =           0.77783067e-3f;
      sum = sum * t - 0.2777655457e-2f;
      sum = sum * t + 0.83333273853e-1f;
      sum = sum * s + 0.918938533204672f;
      s = 0.5f * __internal_accurate_logf(a);
      t = a - 0.5f;
      s = s * t;
      t = s - a;
      s = s + sum;
      t = t + s;
      return t;
    } else {
      a = a - 3.0f;
      s =       - 7.488903254816711E+002f;
      s = s * a - 1.234974215949363E+004f;
      s = s * a - 4.106137688064877E+004f;
      s = s * a - 4.831066242492429E+004f;
      s = s * a - 1.430333998207429E+005f;
      t =     a - 2.592509840117874E+002f;
      t = t * a - 1.077717972228532E+004f;
      t = t * a - 9.268505031444956E+004f;
      t = t * a - 2.063535768623558E+005f;
      t = s / t;
      t = t + a;
      return t;
    }
  } else if (a >= 1.5f) {
    a = a - 2.0f;
    t =       + 4.959849168282574E-005f;
    t = t * a - 2.208948403848352E-004f;
    t = t * a + 5.413142447864599E-004f;
    t = t * a - 1.204516976842832E-003f;
    t = t * a + 2.884251838546602E-003f;
    t = t * a - 7.382757963931180E-003f;
    t = t * a + 2.058131963026755E-002f;
    t = t * a - 6.735248600734503E-002f;
    t = t * a + 3.224670187176319E-001f;
    t = t * a + 4.227843368636472E-001f;
    t = t * a;
    return t;
  } else if (a >= 0.7f) {
    a = 1.0f - a;
    t =       + 4.588266515364258E-002f;
    t = t * a + 1.037396712740616E-001f;
    t = t * a + 1.228036339653591E-001f;
    t = t * a + 1.275242157462838E-001f;
    t = t * a + 1.432166835245778E-001f;
    t = t * a + 1.693435824224152E-001f;
    t = t * a + 2.074079329483975E-001f;
    t = t * a + 2.705875136435339E-001f;
    t = t * a + 4.006854436743395E-001f;
    t = t * a + 8.224669796332661E-001f;
    t = t * a + 5.772156651487230E-001f;
    t = t * a;
    return t;
  } else {
    t =       + 3.587515669447039E-003f;
    t = t * a - 5.471285428060787E-003f;
    t = t * a - 4.462712795343244E-002f;
    t = t * a + 1.673177015593242E-001f;
    t = t * a - 4.213597883575600E-002f;
    t = t * a - 6.558672843439567E-001f;
    t = t * a + 5.772153712885004E-001f;
    t = t * a;
    t = t * a + a;
    return -__internal_accurate_logf(t);
  }
}


static float __internal_sin_kernel(float x)
{
  float x2, z;

  x2 = x * x;
  z  =        - 1.95152959e-4f;
  z  = z * x2 + 8.33216087e-3f;
  z  = z * x2 - 1.66666546e-1f;
  z  = z * x2;
  z  = z * x + x;

  return z;
}


static float __internal_cos_kernel(float x)
{
  float x2, z;

  x2 = x * x;
  z  =          2.44331571e-5f;
  z  = z * x2 - 1.38873163e-3f;
  z  = z * x2 + 4.16666457e-2f;
  z  = z * x2 - 5.00000000e-1f;
  z  = z * x2 + 1.00000000e+0f;
  return z;
}

static float __internal_accurate_sinf(float a)
{
  float z;
  int   i;

  if (__cuda___isinff(a)) {
    return __int_as_float(0x7fffffff);
  }
  if (a == 0.0f) {
    return a;
  }
  z = __internal_trig_reduction_kernel(a, &i);
  
  if (i & 1) {
    z = __internal_cos_kernel(z);
  } else {
    z = __internal_sin_kernel(z);
  }
  if (i & 2) {
    z = -z;
  }
  return z;
}







static float __cuda_rintf(float a)
{
  return __cuda_nearbyintf(a);
}

static float __cuda_sinf(float a)
{


#line 1592 "c:\\cuda\\include\\math_functions.h"
  return __internal_accurate_sinf(a);
#line 1594 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_cosf(float a)
{


#line 1601 "c:\\cuda\\include\\math_functions.h"
  float z;
  int i;

  if (__cuda___isinff(a)) {
    return __int_as_float(0x7fffffff);
  }
  z = __internal_trig_reduction_kernel(a, &i);
  
  i++;
  if (i & 1) {
    z = __internal_cos_kernel(z);
  } else {
    z = __internal_sin_kernel(z);
  }
  if (i & 2) {
    z = -z;
  }
  return z;
#line 1620 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_tanf(float a)
{


#line 1627 "c:\\cuda\\include\\math_functions.h"
  float z;
  int   i;

  if (__cuda___isinff(a)) {
    return __int_as_float(0x7fffffff);
  }
  z = __internal_trig_reduction_kernel(a, &i);
  
  z = __internal_tan_kernel(z);
  if (i & 1) {
    z = -1.0f / z;
  }
  return z;
#line 1641 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_log2f(float a)
{


#line 1648 "c:\\cuda\\include\\math_functions.h"
  return __internal_accurate_log2f(a);
#line 1650 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_expf(float a)
{


#line 1657 "c:\\cuda\\include\\math_functions.h"
  return __internal_accurate_expf(a);
#line 1659 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_exp10f(float a)
{


#line 1666 "c:\\cuda\\include\\math_functions.h"
  return __internal_accurate_exp10f(a);
#line 1668 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_coshf(float a)
{
  float z;

  a = __cuda_fabsf(a);
  z = __internal_expf_kernel(a, -2.0f);
  z = 2.0f * z + 0.125f / z;
  if (a >= 90.0f) {
    z = __int_as_float(0x7f800000);     
  }
  return z;
}

static float __cuda_sinhf(float a)
{
  float s, z;

  s = a;
  a = __cuda_fabsf(a);
  if (a < 1.0f) {         
    float a2 = a * a;
    
    z =          2.816951222e-6f;
    z = z * a2 + 1.983615978e-4f;
    z = z * a2 + 8.333350058e-3f;
    z = z * a2 + 1.666666650e-1f;
    z = z * a2;
    z = z * a + a;
  } else {
    z = __internal_expf_kernel(a, -2.0f);
    z = 2.0f * z - 0.125f / z;
    if (a >= 90.0f) {
      z = __int_as_float(0x7f800000);     
    }
  }
  return __cuda_copysignf(z, s);
}

static float __cuda_tanhf(float a)
{
  float t;

  t = __cuda_fabsf(a);
  if (t < 0.55f) {
    float z, z2;
    z = t;
    z2 = z * z;
    t =          1.643758066599993e-2f;
    t = t * z2 - 5.267181327760551e-2f;
    t = t * z2 + 1.332072505223051e-1f;
    t = t * z2 - 3.333294663641083e-1f;
    t = t * z2;
    t = t * z + z;
  } 
  else if (t < 88.0f) {
    t = 1.0f - 2.0f / (__internal_expf_kernel(2.0f * t, 0.0f) + 1.0f);
  }
  else if (t >= 88.0f) {
    t = 1.0f;
  }
  return __cuda_copysignf(t, a);
}

static float __cuda_atan2f(float a, float b)
{
  float t0, t1, t3;

  
  
  t3 = __cuda_fabsf(b);
  t1 = __cuda_fabsf(a);

  if (t3 == 0.0f && t1 == 0.0f) {
    t3 = __cuda___signbitf(b) ? 3.141592654f : 0;
  } else if (__cuda___isinff(t3) && __cuda___isinff(t1)) {
    t3 = __cuda___signbitf(b) ? 2.356194490f : 0.785398163f;
  } else {
    
    if (t3 < t1) {
      t0 = t1;
      t1 = t3;
    } else {
      t0 = t3;
      t1 = t1;
    }
    t3 = __internal_accurate_fdividef(t1, t0);
    t3 = __internal_atanf_kernel(t3);
    
    if (__cuda_fabsf(a) > __cuda_fabsf(b)) t3 = 1.570796327f - t3;
    if (b < 0.0f)                          t3 = 3.141592654f - t3;
  }
  t3 = __cuda_copysignf(t3, a);

  return t3;
}

static float __cuda_atanf(float a)
{
  float t0, t1;

  
  t0 = __cuda_fabsf(a);
  t1 = t0;
  if (t0 > 1.0f) {
    t1 = 1.0f / t1;
  }
  
  t1 = __internal_atanf_kernel(t1);
  
  if (t0 > 1.0f) {
    t1 = 1.570796327f - t1;
  }
  return __cuda_copysignf(t1, a);
}


static float __internal_asinf_kernel(float a)
{
  float t2, t3, t4;

  t2 = a * a;
  t3 =         - 0.501162291f;
  t3 = t3 * t2 + 0.915201485f;
  t3 = t3 * t2;
  t3 = t3 * a;
  t4 = t2      - 5.478654385f;
  t4 = t4 * t2 + 5.491230488f;
  t4 = 1.0f / t4;
  a = t3 * t4 + a;
  return a;
}

static float __cuda_asinf(float a)
{
  float t0, t1, t2;

  t0 = __cuda_fabsf(a);
  t2 = 1.0f - t0;
  t2 = 0.5f * t2;
  t2 = __cuda_sqrtf(t2);
  t1 = t0 > 0.575f ? t2 : t0;
  t1 = __internal_asinf_kernel(t1);
  t2 = -2.0f * t1 + 1.570796327f;
  if (t0 > 0.575f) {
    t1 = t2;
  }
  return __cuda_copysignf(t1, a);
}

static float __cuda_acosf(float a)
{
  float t0, t1, t2;

  t0 = __cuda_fabsf(a);
  t2 = 1.0f - t0;
  t2 = 0.5f * t2;
  t2 = __cuda_sqrtf(t2);
  t1 = t0 > 0.575f ? t2 : t0;
  t1 = __internal_asinf_kernel(t1);
  t1 = t0 > 0.575f ? 2.0f * t1 : 1.570796327f - t1;
  if (__cuda___signbitf(a)) {
    t1 = 3.141592654f - t1;
  }
  return t1;
}

static float __cuda_logf(float a)
{


#line 1841 "c:\\cuda\\include\\math_functions.h"
  return __internal_accurate_logf(a);
#line 1843 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_log10f(float a)
{


#line 1850 "c:\\cuda\\include\\math_functions.h"
  return 0.434294482f * __internal_accurate_logf(a);
#line 1852 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_log1pf(float a)
{
  float t;



#line 1861 "c:\\cuda\\include\\math_functions.h"
  if (a >= -0.394f && a <= 0.65f) {
    
    t = a + 2.0f;
    t = a / t;
    t = -a * t;
    t = __internal_atanhf_kernel (a, t);
  } else {
    t = __internal_accurate_logf (1.0f + a);
  }
  return t;
}

static float __cuda_acoshf(float a)
{
  float s, t;

  t = a - 1.0f;
  if (__cuda_fabsf(t) > 8388608.0f) {
    
    return 0.693147181f + __internal_accurate_logf(a);
  } else {
    s = a + 1.0f;
    t = t + __cuda_sqrtf(s * t);
    return __cuda_log1pf(t);
  }
}

static float __cuda_asinhf(float a)
{
  float fa, oofa, t;

  fa = __cuda_fabsf(a);
  if (fa > 8.507059173e37f) {   
    t = 0.693147181f + __logf(fa);  
  } else {
    oofa = 1.0f / fa;
    t = fa + fa / (oofa + __cuda_sqrtf(1.0f + oofa * oofa));
    t = __cuda_log1pf(t);
  }
  return __cuda_copysignf(t, a);
}

static float __cuda_atanhf(float a)
{
  float fa, t;

  fa = __cuda_fabsf(a);
  t = (2.0f * fa) / (1.0f - fa);
  t = 0.5f * __cuda_log1pf(t);
  return __cuda_copysignf(t, a);
}

static float __cuda_expm1f(float a)
{
  float t, z, j, u;
  
  t = __cuda_rintf (a * 1.442695041f);
  z = a - t * 0.6931457519f;
  z = z - t * 1.4286067653e-6f;
  
  if (__cuda_fabsf(a) < 0.41f) {
    z = a;
    t = 0.0f;
  }
  
  j = t;
  if (t == 128.0f) j = j - 1.0f; 
  
  u =         1.38795078474044430E-003f;
  u = u * z + 8.38241261853264930E-003f;
  u = u * z + 4.16678317762833940E-002f;
  u = u * z + 1.66663978874356580E-001f;
  u = u * z + 4.99999940395997040E-001f;
  u = u * z;
  u = u * z + z;
  if (a == 0.0f) u = a;            
  
  z = __cuda_exp2f (j);
  a = z - 1.0f;
  if (a != 0.0f)   u = u * z + a;  
  if (t == 128.0f) u = u + u;      
  
  if (j >  128.0f) u = __int_as_float(0x7f800000);
  if (j <  -25.0f) u = -1.0f;
  return u;
}

static float __cuda_hypotf(float a, float b)
{
  float v, w, t;

  a = __cuda_fabsf(a);
  b = __cuda_fabsf(b);
  
  if (a > b) {
    v = a;
    w = b; 
  } else {
    v = b;
    w = a;
  }
  t = __internal_accurate_fdividef(w, v);
  t = 1.0f + t * t;
  t = v * __cuda_sqrtf(t);
  if (v == 0.0f) {
    t = v + w;
  }
  if ((v == __int_as_float(0x7f800000)) || (w == __int_as_float(0x7f800000))) {
    t = __int_as_float(0x7f800000);
  }
  return t;
}

static float __cuda_cbrtf(float a)
{
  float s, t;
  if (a == 0.0f || __cuda___isinff(a)) {
    return a;
  } 
  s = __cuda_fabsf(a);
  t = __cuda_exp2f(0.333333333f * __log2f(s)); 
  t = t - (t - (s / (t * t))) * 0.333333333f;  
  if (__cuda___signbitf(a)) {
     t = -t;
  }
  return t;
}

static float __cuda_erff(float a)
{
  float t, r, q;

  t = __cuda_fabsf(a);
  if (t < 1.0f) {
    t = t * t;
    r =        -5.58510127926029810E-004f;
    r = r * t + 4.90688891415893070E-003f;
    r = r * t - 2.67027980930150640E-002f;
    r = r * t + 1.12799056505903940E-001f;
    r = r * t - 3.76122956138427440E-001f;
    r = r * t + 1.12837911712623450E+000f;
    a = a * r;
  } else if (t <= __int_as_float(0x7f800000)) { 
    


    q = 0.3275911f * t + 1.0f;
    q = 1.0f / q;
    r =         1.061405429f;
    r = r * q - 1.453152027f;
    r = r * q + 1.421413741f;
    r = r * q - 0.284496736f;
    r = r * q + 0.254829592f;
    r = r * q;
    q = __internal_expf_kernel(-a * a, 0.0f);
    r = 1.0f - q * r;
    if (t >= 5.5f) {
      r = 1.0f;
    }
    a = __int_as_float (__float_as_int(r) | (__float_as_int(a) & 0x80000000));
  }
  return a;
}

static float __cuda_erfcf(float a)
{
  if (a <= 0.55f) {
    return 1.0f - __cuda_erff(a);
  } else if (a > 10.0f) {
    return 0.0f;
  } else {
    float p;
    float q;
    float h;
    float l;
    



    p =       + 4.014893410762552E-006f;
    p = p * a + 5.640401259462436E-001f;
    p = p * a + 2.626649872281140E+000f;
    p = p * a + 5.486372652389673E+000f;
    p = p * a + 5.250714831459401E+000f;
    q =     a + 4.651376250488319E+000f;
    q = q * a + 1.026302828878470E+001f;
    q = q * a + 1.140762166021288E+001f;
    q = q * a + 5.251211619089947E+000f;
    
    h = 1.0f / q;
    q = 2.0f * h - q * h * h;
    p = p * q;
    
    h = __int_as_float(__float_as_int(a) & 0xfffff000);  
    l = a - h;  
    q = -h * h; 
    q = __internal_expf_kernel(q, 0.0f);
    if (l != 0.0f) {
      a = a + h;
      l = l * a;
      h = __internal_expf_kernel(-l, 0.0f);
      q = q * h;
    }
    p = p * q;
    return p;
  }
}

static float __cuda_lgammaf(float a)
{
  float t;
  float i;
  int quot;
  t = __internal_lgammaf_pos(__cuda_fabsf(a));
  if (a >= 0.0f) return t;
  a = __cuda_fabsf(a);
  i = __cuda_floorf(a);                   
  if (a == i) return __int_as_float(0x7f800000); 
  if (a < 1e-19f) return -__internal_accurate_logf(a);
  i = __cuda_rintf (2.0f * a);
  quot = (int)i;
  i = a - 0.5f * i;
  i = i * 3.141592654f;
  if (quot & 1) {
    i = __internal_cos_kernel(i);
  } else {
    i = __internal_sin_kernel(i);
  }
  i = __cuda_fabsf(i);
  t = 1.144729886f - __internal_accurate_logf(i * a) - t;
  return t;
}

static float __cuda_ldexpf(float a, int b)
{
  float fa = __cuda_fabsf(a);

  if (fa == 0.0f || __cuda___isinff(fa) || b == 0) {
    return a;
  } 
  else if (__cuda_abs(b) < 126) {
    return a * __cuda_exp2f((float)b);
  }
  else if (__cuda_abs(b) < 252) {
    int bhalf = b / 2;
    return a * __cuda_exp2f((float)bhalf) * __cuda_exp2f((float)(b - bhalf));
  } 
  else {
    int bquarter = b / 4;
    float t = __cuda_exp2f((float)bquarter);
    return a * t * t * t * __cuda_exp2f((float)(b - 3 * bquarter));
  }
}

static float __cuda_scalbnf(float a, int b)
{
  
  return __cuda_ldexpf(a, b);
}

static float __cuda_scalblnf(float a, long int b)
{
  int t;
  if (b > 2147483647L) {
    t = 2147483647;
  } else if (b < (-2147483647 - 1)) {
    t = (-2147483647 - 1);
  } else {
    t = (int)b;
  }
  return __cuda_scalbnf(a, t);
}

static float __cuda_frexpf(float a, int *b)
{
  float fa = __cuda_fabsf(a);
  unsigned int expo;
  unsigned int denorm;

  if (fa < 1.175494351e-38f) {
    a *= 16777216.0f;
    denorm = 24;
  } else {
    denorm = 0;
  }
  expo = ((__float_as_int(a) >> 23) & 0xff);
  if ((fa == 0.0f) || (expo == 0xff)) {
    expo = 0;
    a = a + a;
  } else {  
    expo = expo - denorm - 126;
    a = __int_as_float(((__float_as_int(a) & 0x807fffff) | 0x3f000000));
  }
  *b = expo;
  return a;
}

static float __cuda_modff(float a, float *b)
{
  float t;
  if (__cuda___finitef(a)) {
    t = __cuda_truncf(a);
    *b = t;
    t = a - t;
    return __cuda_copysignf(t, a);
  } else if (__cuda___isinff(a)) {
    t = 0.0f;
    *b = a;
    return __cuda_copysignf(t, a);
  } else {
    *b = a; 
    return a;
  }
}

static float __cuda_fmodf(float a, float b)
{
  float orig_a;

  if (__cuda___isnanf(a) || __cuda___isnanf(b)) {
    return a + b;
  }
  orig_a = a;
  a = __cuda_fabsf(a);
  b = __cuda_fabsf(b);
  if (__cuda___isinff(a) || b == 0.0f) {
    return __int_as_float(0x7fffffff);
  } else if (a >= b) {











#line 2201 "c:\\cuda\\include\\math_functions.h"
    float scaled_b = __int_as_float ((__float_as_int(b) & 0x007fffff) | 
                                     (__float_as_int(a) & 0x7f800000));
    if (scaled_b > a) {
      scaled_b *= 0.5f;
    }
#line 2207 "c:\\cuda\\include\\math_functions.h"
    while (scaled_b >= b) {
      if (a >= scaled_b) {
        a -= scaled_b;
      }
      scaled_b *= 0.5f;
    }
    return __cuda_copysignf(a, orig_a);
  } else {
    return orig_a;
  }
}

static float __cuda_remainderf(float a, float b)
{
  float orig_a;
  float twoa = 0.0f;
  unsigned int quot0 = 0;  

  if (__cuda___isnanf(a) || __cuda___isnanf(b)) {
    return a + b;
  }
  orig_a = a;
  a = __cuda_fabsf(a);
  b = __cuda_fabsf(b);
  if (__cuda___isinff(a) || (b == 0.0f)) {
    return __int_as_float(0x7fffffff);
  } else if (a >= b) {










#line 2245 "c:\\cuda\\include\\math_functions.h"
    float scaled_b = __int_as_float ((__float_as_int(b) & 0x007fffff) | 
                                     (__float_as_int(a) & 0x7f800000));
    if (scaled_b > a) {
      scaled_b *= 0.5f;
    }
    
    if (a == scaled_b) {
      return __int_as_float(__float_as_int(orig_a) & 0x80000000);
    }    
#line 2255 "c:\\cuda\\include\\math_functions.h"
    while (scaled_b >= b) {
      quot0 = 0;
      if (a >= scaled_b) {
        twoa = (2.0f * a - scaled_b) - scaled_b;
        a -= scaled_b;
        quot0 = 1;
      }
      scaled_b *= 0.5f;
    }
  }
  






#line 2273 "c:\\cuda\\include\\math_functions.h"
  if (a >= 1.175494351e-38f) {
    twoa = 2.0f * a;
    if ((twoa > b) || ((twoa == b) && quot0)) {
      a -= b;
      a = __cuda_copysignf (a, -1.0f);
    }
  } else {
    
    if ((twoa > b) || ((twoa == b) && quot0)) {
      a = 0.5f * (twoa - 2.0f * b);
      a = __cuda_copysignf (a, -1.0f);
    }
  }
#line 2287 "c:\\cuda\\include\\math_functions.h"
  a = __int_as_float((__float_as_int(orig_a) & 0x80000000)^
                     __float_as_int(a));
  return a;
}

static float __cuda_remquof(float a, float b, int* quo)
{
  float orig_a;
  float twoa = 0.0f;
  unsigned int quot = 0;  
  unsigned int sign;

  if (__cuda___isnanf(a) || __cuda___isnanf(b)) {
    *quo = quot;
    return a + b;
  }
  orig_a = a;
  
  sign = 0 - (__cuda___signbitf(a) != __cuda___signbitf(b));
  a = __cuda_fabsf(a);
  b = __cuda_fabsf(b);
  if (__cuda___isinff(a) || (b == 0.0f)) {
    *quo = quot;
    return __int_as_float(0x7fffffff);
  } else if (a >= b) {











#line 2324 "c:\\cuda\\include\\math_functions.h"
    float scaled_b = __int_as_float ((__float_as_int(b) & 0x007fffff) | 
                                     (__float_as_int(a) & 0x7f800000));
    if (scaled_b > a) {
      scaled_b *= 0.5f;
    }
    
    if (a == scaled_b) {
      a = __internal_accurate_fdividef(a,b) + 0.5f;
      quot = (a < 8.0f) ? (int)a : 0;
      quot = quot & (~((~0)<<3));
      quot = quot ^ sign;
      quot = quot - sign;
      *quo = quot;
      return __int_as_float(__float_as_int(orig_a) & 0x80000000);
    }    
#line 2340 "c:\\cuda\\include\\math_functions.h"
    while (scaled_b >= b) {
      quot <<= 1;
      if (a >= scaled_b) {
        twoa = (2.0f * a - scaled_b) - scaled_b;
        a -= scaled_b;
        quot += 1;
      }
      scaled_b *= 0.5f;
    }
  }
  







#line 2359 "c:\\cuda\\include\\math_functions.h"
  if (a >= 1.175494351e-38f) {
    twoa = 2.0f * a;
    if ((twoa > b) || ((twoa == b) && (quot & 1))) {
      quot++;
      a -= b;
      a = __cuda_copysignf (a, -1.0f);
    }
  } else {
    
    if ((twoa > b) || ((twoa == b) && (quot & 1))) {
      quot++;
      a = 0.5f * (twoa - 2.0f * b);
      a = __cuda_copysignf (a, -1.0f);
    }
  }
#line 2375 "c:\\cuda\\include\\math_functions.h"
  a = __int_as_float((__float_as_int(orig_a) & 0x80000000)^
                     __float_as_int(a));
  quot = quot & (~((~0)<<3));
  quot = quot ^ sign;
  quot = quot - sign;
  *quo = quot;
  return a;
}

static float __cuda_fmaf(float a, float b, float c)
{
  unsigned int xx, yy, zz, ww;
  unsigned int temp, s, u;
  unsigned int expo_x, expo_y, expo_z;

  xx = __float_as_int(a);
  yy = __float_as_int(b);
  zz = __float_as_int(c);


  
  if ((xx << 1) < 0x01000000) xx &= 0x80000000;
  if ((yy << 1) < 0x01000000) yy &= 0x80000000;
  if ((zz << 1) < 0x01000000) zz &= 0x80000000;
#line 2400 "c:\\cuda\\include\\math_functions.h"

  temp = 0xff;
  expo_x = temp & (xx >> 23);
  expo_x = expo_x - 1;
  expo_y = temp & (yy >> 23);
  expo_y = expo_y - 1;
  expo_z = temp & (zz >> 23);
  expo_z = expo_z - 1;

  if (!((expo_x <= 0xFD) && 
        (expo_y <= 0xFD) &&
        (expo_z <= 0xFD))) {
    



    if ((yy << 1) > 0xff000000) {
      return __int_as_float(0x7fffffff);
    }
    if ((zz << 1) > 0xff000000) {
      return __int_as_float(0x7fffffff);
    }
    if ((xx << 1) > 0xff000000) {
      return __int_as_float(0x7fffffff);
    }
    










    if ((((xx << 1) == 0) && ((yy << 1) == 0xff000000)) ||
        (((yy << 1) == 0) && ((xx << 1) == 0xff000000))) {
      return __int_as_float(0x7fffffff);
    }
    if ((zz << 1) == 0xff000000) {
      if (((yy << 1) == 0xff000000) || ((xx << 1) == 0xff000000)) {
        if ((int)(xx ^ yy ^ zz) < 0) {
          return __int_as_float(0x7fffffff);
        }
      }
    }
    



    if ((xx << 1) == 0xff000000) {
      xx = xx ^ (yy & 0x80000000);
      return __int_as_float(xx);
    }
    if ((yy << 1) == 0xff000000) {
      yy = yy ^ (xx & 0x80000000);
      return __int_as_float(yy);
    }
    if ((zz << 1) == 0xff000000) {
      return __int_as_float(zz);
    }
    




    if (zz == 0x80000000) {
      if (((xx << 1) == 0) || ((yy << 1) == 0)) {
        if ((int)(xx ^ yy) < 0) {
          return __int_as_float(zz);
        }
      }
    }
    


    if (((zz << 1) == 0) && 
        (((xx << 1) == 0) || ((yy << 1) == 0))) {
      zz &= 0x7fffffff;
      return __int_as_float(zz);
    }
    


    if (((xx << 1) == 0) || ((yy << 1) == 0)) {
      return __int_as_float(zz);
    }
    
    if (expo_x == (unsigned int)-1) {
      temp = xx & 0x80000000;
      xx = xx << 8;
      while (!(xx & 0x80000000)) {
        xx <<= 1;
        expo_x--;
      }
      expo_x++;
      xx = (xx >> 8) | temp;
    }
    
    if (expo_y == (unsigned int)-1) {
      temp = yy & 0x80000000;
      yy = yy << 8;
      while (!(yy & 0x80000000)) {
        yy <<= 1;
        expo_y--;
      }
      expo_y++;
      yy = (yy >> 8) | temp;
    }
    
    if ((expo_z == (unsigned int)-1) && ((zz << 1) != 0)) {
      temp = zz & 0x80000000;
      zz = zz << 8;
      while (!(zz & 0x80000000)) {
        zz <<= 1;
        expo_z--;
      }
      expo_z++;
      zz = (zz >> 8) | temp;
    }
  }
    
  expo_x = expo_x + expo_y;
  expo_y = xx ^ yy;
  xx = xx & 0x00ffffff;
  yy = yy << 8;
  xx = xx | 0x00800000;
  yy = yy | 0x80000000;
  
  s = __umulhi(xx, yy);
  yy = xx * yy;
  xx = s;
  expo_x = expo_x - 127 + 2;
  expo_y = expo_y & 0x80000000;

  
  if (xx < 0x00800000) {
      xx = (xx << 1) | (yy >> 31);
      yy = (yy << 1);
      expo_x--;
  }
  temp = 0;
  if ((zz << 1) != 0) { 
    s = zz & 0x80000000;
    zz &= 0x00ffffff;
    zz |= 0x00800000;
    ww = 0;
    
    if ((int)expo_z > (int)expo_x) {
      temp = expo_z;
      expo_z = expo_x;
      expo_x = temp;
      temp = zz;
      zz = xx;
      xx = temp;
      temp = ww;
      ww = yy;
      yy = temp;
      temp = expo_y;
      expo_y = s;
      s = temp;
    }
    
    
    expo_z = expo_x - expo_z;
    u = expo_y ^ s;
    if (expo_z <= 49) {
      
      temp = 0;
      while (expo_z >= 32) {
        temp = ww | (temp != 0);
        ww = zz;
        zz = 0;
        expo_z -= 32;
      }
      if (expo_z) {
        temp = ((temp >> expo_z) | (ww << (32 - expo_z)) | 
                ((temp << (32 - expo_z)) != 0));
        ww = (ww >> expo_z) | (zz << (32 - expo_z));
        zz = (zz >> expo_z);
      }
    } else {
      temp = 1;
      ww = 0;
      zz = 0;
    }            
    if ((int)u < 0) {
      
      temp = (unsigned)(-(int)temp);
      s = (temp != 0);
      u = yy - s;
      s = u > yy;
      yy = u - ww;
      s += yy > u;
      xx = (xx - zz) - s;
      if (!(xx | yy | temp)) {
        
        return __int_as_float(xx);
      }
      if ((int)xx < 0) {
        


        temp = ~temp;
        yy = ~yy;
        xx = ~xx;
        if (++temp == 0) {
          if (++yy == 0) {
            ++xx;
          }
        }
        expo_y ^= 0x80000000;
      }
      
      while (!(xx & 0x00800000)) {
        xx = (xx << 1) | (yy >> 31);
        yy = (yy << 1);
        expo_x--;
      }
    } else {
      
      yy = yy + ww;
      s =  yy < ww;
      xx = xx + zz + s;
      if (xx & 0x01000000) {
        temp = temp | (yy << 31);
        yy = (yy >> 1) | (xx << 31);
        xx = ((xx & 0x80000000) | (xx >> 1)) & ~0x40000000;
        expo_x++;
      }
    }
  }
  temp = yy | (temp != 0);
  if (expo_x <= 0xFD) {
    
    xx |= expo_y; 
    s = xx & 1; 
    xx += (temp == 0x80000000) ? s : (temp >> 31);
    xx = xx + (expo_x << 23); 
    return __int_as_float(xx);
  } else if ((int)expo_x >= 126) {
    
    xx = expo_y | 0x7f800000;
    return __int_as_float(xx);
  }
  
  expo_x = (unsigned int)(-(int)expo_x);
  if (expo_x > 25) {
    
    return __int_as_float(expo_y);
  }
  yy = (xx << (32 - expo_x)) | ((yy) ? 1 : 0);
  xx = expo_y + (xx >> expo_x);
  xx = xx + ((yy==0x80000000) ? (xx & 1) : (yy >> 31));
  xx |= expo_y; 

  
  if ((xx << 1) < 0x01000000) xx = expo_y;
#line 2660 "c:\\cuda\\include\\math_functions.h"
  return __int_as_float(xx);
}

static __attribute__((__constant__)) float __cudart_A1[32] = 
{
  1.0000000000e+000f,
  1.0218971968e+000f,
  1.0442737341e+000f,
  1.0671404600e+000f,
  1.0905077457e+000f,
  1.1143867970e+000f,
  1.1387885809e+000f,
  1.1637248993e+000f,
  1.1892070770e+000f,
  1.2152473927e+000f,
  1.2418577671e+000f,
  1.2690509558e+000f,
  1.2968395948e+000f,
  1.3252366781e+000f,
  1.3542555571e+000f,
  1.3839099407e+000f,
  1.4142135382e+000f,
  1.4451807737e+000f,
  1.4768261909e+000f,
  1.5091644526e+000f,
  1.5422108173e+000f,
  1.5759809017e+000f,
  1.6104903221e+000f,
  1.6457555294e+000f,
  1.6817928553e+000f,
  1.7186193466e+000f,
  1.7562521696e+000f,
  1.7947090864e+000f,
  1.8340080976e+000f,
  1.8741676807e+000f,
  1.9152065516e+000f,
  1.9571441412e+000f
};

static __attribute__((__constant__)) float __cudart_A2[32] = 
{
  0.0000000000e+000f,
 -4.8115598617e-008f,
  4.8334701575e-008f,
 -5.9337519787e-008f,
 -1.3077539940e-008f,
 -5.4355400181e-008f,
  5.3862223126e-008f,
 -4.0514414934e-008f,
  3.7976352729e-008f,
 -3.2673948880e-008f,
  4.4968381019e-008f,
  1.4193333175e-009f,
 -4.0189995332e-008f,
 -3.4963733242e-008f,
 -1.0123349270e-008f,
 -5.8755773580e-008f,
  2.4203234972e-008f,
  3.3241999375e-008f,
 -4.5008988536e-008f,
 -2.4959373235e-008f,
  8.0709048333e-009f,
 -5.6610254262e-008f,
  9.8362171741e-009f,
 -5.1249720912e-008f,
 -2.4755326677e-008f,
 -4.8496175964e-008f,
 -9.2357703707e-009f,
 -1.1415044909e-008f,
 -1.1239277953e-008f,
 -4.6630056261e-008f,
  9.8453281083e-009f,
 -1.7021804410e-008f
};

static __attribute__((__constant__)) float __cudart_Ainv[32] = 
{
  1.0000000000e+000f,
  9.7857207060e-001f,
  9.5760327578e-001f,
  9.3708384037e-001f,
  9.1700404882e-001f,
  8.9735454321e-001f,
  8.7812608480e-001f,
  8.5930967331e-001f,
  8.4089642763e-001f,
  8.2287776470e-001f,
  8.0524516106e-001f,
  7.8799045086e-001f,
  7.7110540867e-001f,
  7.5458222628e-001f,
  7.3841309547e-001f,
  7.2259038687e-001f,
  7.0710676908e-001f,
  6.9195497036e-001f,
  6.7712777853e-001f,
  6.6261833906e-001f,
  6.4841979742e-001f,
  6.3452547789e-001f,
  6.2092888355e-001f,
  6.0762369633e-001f,
  5.9460353851e-001f,
  5.8186244965e-001f,
  5.6939429045e-001f,
  5.5719339848e-001f,
  5.4525387287e-001f,
  5.3357023001e-001f,
  5.2213686705e-001f,
  5.1094859838e-001f
};

static float __internal_accurate_powf(float a, float b)
{
  int i;
  float t;
  int expo;
  float log_hi, log_lo;
  float b_hi, b_lo;
  float prod_hi, prod_lo;
  
  if ((a > 0.707106781f) && (a < 1.414213562f)) {
    float f, g, u, v, q;

    




    f = a - 1.0f;
    g = a + 1.0f;
    g = 1.0f / g;
    u = 2.0f * f * g;
    v = u * u;
    q =         1.49356810919559350E-001f/64.0f;
    q = q * v + 1.99887797540072460E-001f/16.0f;
    q = q * v + 3.33333880955515580E-001f/4.0f;
    q = q * v;
    q = q * u;
    log_hi = __int_as_float(__float_as_int(u) & 0xfffff000);
    v = __int_as_float(__float_as_int(f) & 0xfffff000);
    u = 2.0f * (f - log_hi);
    f = f - v;
    u = u - log_hi * v;
    u = u - log_hi * f;
    u = g * u;
    log_lo = q + u;

    
    b_hi = __int_as_float(__float_as_int(b) & 0xfffff000);
    b_lo = b - b_hi;
    prod_lo  = b_lo * log_lo;
    prod_lo += b_lo * log_hi;
    prod_lo += b_hi * log_lo;
    prod_hi  = b_hi * log_hi;

    
    return __cuda_expf(prod_hi) * __cuda_expf(prod_lo);
  }

  
  if (a >= 1.175494351e-38f) {
    i = __float_as_int(a);
    expo = ((i >> 23) & 0xff) - 127;
  } else {
    a *= 16777216.0f;
    i = __float_as_int(a);
    expo = ((i >> 23) & 0xff) - 127 - 24;
  }   
  i = (i & 0x007fffff) | (0x3f800000);
  t = __int_as_float(i);

  i = 0;
  if (t >= __cudart_A1[i+16]) i += 16;
  if (t >= __cudart_A1[i+8])  i += 8;
  if (t >= __cudart_A1[i+4])  i += 4;
  if (t >= __cudart_A1[i+2])  i += 2;
  if (t >= __cudart_A1[i+1])  i += 1;

  t = t - __cudart_A1[i];
  t = t - __cudart_A2[i];
  
  t = t * __cudart_Ainv[i];

  
  log_hi = (float)expo + (float)i * 0.03125f;
  
  log_lo =            - 3.42338934684934650E-001f;
  log_lo = log_lo * t + 4.80524913518140690E-001f;
  log_lo = log_lo * t - 7.21345070621603800E-001f;
  log_lo = log_lo * t + 1.44269503837073180E+000f;
  log_lo = log_lo * t;

  
  b_hi   = __int_as_float(__float_as_int(b) & 0xfffff000);
  b_lo   = b - b_hi;
  prod_lo = b_lo * log_lo;  
  prod_lo = prod_lo + b_lo * log_hi;
  prod_lo = prod_lo + b_hi * log_lo;
  prod_hi = b_hi * log_hi;

  
  if (prod_hi >= 256.0f) {
    return __int_as_float(0x7f800000);
  }
  if (prod_hi <= -256.0f) {
    return 0.0f;
  }

  
  b = __cuda_exp2f (0.5f * prod_hi);
  t = __cuda_exp2f (prod_lo);
  t = t * b;
  t = t * b;
  return t;
}

static float __cuda_powif(float a, int b)
{
  unsigned int e = __cuda_abs(b);
  float        r = 1.0f;

  while (1) {
    if ((e & 1) != 0) {
      r = r * a;
    }
    e = e >> 1;
    if (e == 0) {
      return b < 0 ? 1.0f/r : r;
    }
    a = a * a;
  }
}

static double __cuda_powi(double a, int b)
{
  unsigned int e = __cuda_abs(b);
  double       r = 1.0;

  while (1) {
    if ((e & 1) != 0) {
      r = r * a;
    }
    e = e >> 1;
    if (e == 0) {
      return b < 0 ? 1.0/r : r;
    }
    a = a * a;
  }
}

static float __cuda_powf(float a, float b)
{


#line 2915 "c:\\cuda\\include\\math_functions.h"
  int bIsOddInteger;
  float t;
  if (a == 1.0f || b == 0.0f) {
    return 1.0f;
  } 
  if (__cuda___isnanf(a) || __cuda___isnanf(b)) {
    return a + b;
  }
  if (a == __int_as_float(0x7f800000)) {
    return __cuda___signbitf(b) ? 0.0f : __int_as_float(0x7f800000);
  }
  if (__cuda___isinff(b)) {
    if (a == -1.0f) {
      return 1.0f;
    }
    t = (__cuda_fabsf(a) > 1.0f) ? __int_as_float(0x7f800000) : 0.0f;
    if (b < 0.0f) {
      t = 1.0f / t;
    }
    return t;
  }
  bIsOddInteger = (b - (2.0f * floorf(0.5f * b))) == 1.0f;
  if (a == 0.0f) {
    t = bIsOddInteger ? a : 0.0f;
    if (b < 0.0f) {
      t = 1.0f / t;
    }
    return t;
  } 
  if (a == -__int_as_float(0x7f800000)) {
    t = (b < 0.0f) ? -1.0f/a : -a;
    if (bIsOddInteger) {
      t = __int_as_float(__float_as_int(t) ^ 0x80000000);
    }
    return t;
  } 
  if ((a < 0.0f) && (b != __cuda_truncf(b))) {
    return __int_as_float(0x7fffffff);
  }
  t = __cuda_fabsf(a);
  t = __internal_accurate_powf(t, b);
  if ((a < 0.0f) && bIsOddInteger) {
    t = __int_as_float(__float_as_int(t) ^ 0x80000000);
  }
  return t;
#line 2961 "c:\\cuda\\include\\math_functions.h"
}


static float __internal_tgammaf_kernel(float a)
{
  float t;
  t =       - 1.05767296987211380E-003f;
  t = t * a + 7.09279059435508670E-003f;
  t = t * a - 9.65347121958557050E-003f;
  t = t * a - 4.21736613253687960E-002f;
  t = t * a + 1.66542401247154280E-001f;
  t = t * a - 4.20043267827838460E-002f;
  t = t * a - 6.55878234051332940E-001f;
  t = t * a + 5.77215696929794240E-001f;
  t = t * a + 1.00000000000000000E+000f;
  return t;
}





static float __cuda_tgammaf(float a)
{
  float s, xx, x=a;
  if (x >= 0.0f) {
    if (x > 36.0f) x = 36.0f; 
    s = 1.0f;
    xx = x;
    if (x > 34.03f) { 
      xx -= 1.0f;
    }
    while (xx > 1.5f) {
      xx = xx - 1.0f;
      s = s * xx;
    }
    if (x >= 0.5f) {
      xx = xx - 1.0f;
    }
    xx = __internal_tgammaf_kernel(xx);
    if (x < 0.5f) {
      xx = xx * x;
    }
    s = s / xx;
    if (x > 34.03f) {
      
      xx = x - 1.0f;
      s = s * xx;
    }
    return s;
  } else {
    if (x == __cuda_floorf(x)) {  
      x = __int_as_float(0x7fffffff);  


#line 3017 "c:\\cuda\\include\\math_functions.h"
    } 
    if (x < -41.1f) x = -41.1f; 
    xx = x;
    if (x < -34.03f) {           
      xx += 6.0f;
    } 
    s = xx;
    while (xx < -0.5f) {
      xx = xx + 1.0f;
      s = s * xx;
    }
    xx = __internal_tgammaf_kernel(xx);
    s = s * xx;
    s = 1.0f / s;
    if (x < -34.03f) {
      xx = x;
      xx *= (x + 1.0f);
      xx *= (x + 2.0f);
      xx *= (x + 3.0f);
      xx *= (x + 4.0f);
      xx *= (x + 5.0f);
      xx = 1.0f / xx;
      s = s * xx;
      if ((a < -42.0f) && !(((int)a)&1)) {
        s = __int_as_float(0x80000000);
      }
    }    
    return s;
  }
}

static float __cuda_roundf(float a)
{
  float fa = __cuda_fabsf(a);
  if (fa > 8388608.0f) {
    return a;
  } else {
    float u = __cuda_floorf(fa + 0.5f);
    if (fa < 0.5f) u = 0.0f;
    return __cuda_copysignf(u, a);
  }
}

static long long int __internal_llroundf_kernel(float a)
{
  unsigned long long int res, t = 0LL;
  int shift;
  unsigned int ia = __float_as_int(a);
  if ((ia << 1) > 0xff000000) return 0LL;
  if ((int)ia >= 0x5f000000) return 0x7fffffffffffffffLL;
  if (ia >= 0xdf000000) return 0x8000000000000000LL;
  shift = 189 - ((ia >> 23) & 0xff);
  res = ((long long int)(((ia << 8) | 0x80000000) >> 1)) << 32;
  if (shift >= 64) {
    t = res;
    res = 0;
  } else if (shift) {
    t = res << (64 - shift);
    res = res >> shift;
  }
  if (t >= 0x8000000000000000LL) {
      res++;
  }
  if ((int)ia < 0) res = (unsigned long long int)(-(long long int)res);
  return (long long int)res;
}

static long long int __cuda_llroundf(float a)
{
  return __internal_llroundf_kernel(a);
}

static long int __cuda_lroundf(float a)
{


#line 3094 "c:\\cuda\\include\\math_functions.h"




#line 3099 "c:\\cuda\\include\\math_functions.h"
  return (long int)(__cuda_roundf(a));
#line 3101 "c:\\cuda\\include\\math_functions.h"
}

static float __cuda_fdimf(float a, float b)
{
  float t;
  t = a - b;    
  if (a <= b) {
    t = 0.0f;
  }
  return t;
}

static int __cuda_ilogbf(float a)
{
  unsigned int i;
  int expo;
  a = __cuda_fabsf(a);
  if (a <= 1.175494351e-38f) {
    
    if (a == 0.0f) {
      expo = -((int)((unsigned int)-1 >> 1))-1;
    } else {
      expo = -126;
      i = __float_as_int(a);
      i = i << 8;
      while ((int)i >= 0) {
        expo--;
        i = i + i;
      }
    }
  } else {
    i = __float_as_int(a);
    expo = ((int)((i >> 23) & 0xff)) - 127;
    if ((i == 0x7f800000)) {
      expo = ((int)((unsigned int)-1 >> 1));
    }
    if ((i > 0x7f800000)) {
      expo = -((int)((unsigned int)-1 >> 1))-1;
    }
  } 
  return expo;
}

static float __cuda_logbf(float a)
{
  unsigned int i;
  int expo;
  float res;


#line 3152 "c:\\cuda\\include\\math_functions.h"
  a = __cuda_fabsf(a);
  if (a <= 1.175494351e-38f) {
    
    if (a == 0.0f) {
      res = -__int_as_float(0x7f800000);
    } else {
      expo = -126;
      i = __float_as_int(a);
      i = i << 8;
      while ((int)i >= 0) {
        expo--;
        i = i + i;
      }
      res = (float)expo;
    }
  } else {
    i = __float_as_int(a);
    expo = ((int)((i >> 23) & 0xff)) - 127;
    res = (float)expo;
    if ((i >= 0x7f800000)) {  
      
      res = a + a;
    }
  } 
  return res;
}

static void __cuda_sincosf(float a, float *sptr, float *cptr)
{


#line 3184 "c:\\cuda\\include\\math_functions.h"
  float t, u, s, c;
  int quadrant;
  if (__cuda___isinff(a)) {
    *sptr = __int_as_float(0x7fffffff);
    *cptr = __int_as_float(0x7fffffff);
    return;
  }
  if (a == 0.0f) {
    *sptr = a;
    *cptr = 1.0f;
    return;
  } 
  t = __internal_trig_reduction_kernel(a, &quadrant);
  u = __internal_cos_kernel(t);
  t = __internal_sin_kernel(t);
  if (quadrant & 1) {
    s = u;
    c = t;
  } else {
    s = t;
    c = u;
  }
  if (quadrant & 2) {
    s = -s;
  }
  quadrant++;
  if (quadrant & 2) {
    c = -c;
  }
  *sptr = s;
  *cptr = c;
#line 3216 "c:\\cuda\\include\\math_functions.h"
}










































































































































































































































































































































































































































































































































































































































































































































































































































































































































































#line 4156 "c:\\cuda\\include\\math_functions.h"

#line 4158 "c:\\cuda\\include\\math_functions.h"





#line 4164 "c:\\cuda\\include\\math_functions.h"



#line 1 "c:\\cuda\\include\\math_functions_dbl_ptx1.h"








































#line 42 "c:\\cuda\\include\\math_functions_dbl_ptx1.h"

#line 1 "c:\\cuda\\include\\crt/func_macro.h"





























































#line 63 "c:\\cuda\\include\\crt/func_macro.h"
#line 44 "c:\\cuda\\include\\math_functions_dbl_ptx1.h"

static double __cuda_fabs(double a)
{
  return (float)__cuda_fabsf((float)a);
}

static double __cuda_fmax(double a, double b)
{
  return (float)__cuda_fmaxf((float)a, (float)b);
}

static double __cuda_fmin(double a, double b)
{
  return (float)__cuda_fminf((float)a, (float)b);
}

static int __cuda___finite(double a)
{
  return __cuda___finitef((float)a);
}

static int __cuda___isinf(double a)
{
  return __cuda___isinff((float)a);
}

static int __cuda___isnan(double a)
{
  return __cuda___isnanf((float)a);
}

static int __cuda___signbit(double a)
{
  return __cuda___signbitf((float)a);
}

static double __cuda_sqrt(double a)
{
  return (double)__cuda_sqrtf((float)a);
}

static double __cuda_rsqrt(double a)
{
  return (double)__cuda_rsqrtf((float)a);
}

static double __cuda_ceil(double a)
{
  return (double)__cuda_ceilf((float)a);
}

static double __cuda_trunc(double a)
{
  return (double)__cuda_truncf((float)a);
}

static double __cuda_floor(double a)
{
  return (double)__cuda_floorf((float)a);
}

static double __cuda_copysign(double a, double b)
{
  return (double)__cuda_copysignf((float)a, (float)b);
}

static double __cuda_sin(double a)
{
  return (double)__cuda_sinf((float)a);
}

static double __cuda_cos(double a)
{
  return (double)__cuda_cosf((float)a);
}

static void __cuda_sincos(double a, double *sptr, double *cptr)
{
  float fs, fc;

  __cuda_sincosf((float)a, &fs, &fc);

  *sptr = (double)fs;
  *cptr = (double)fc;
}

static double __cuda_tan(double a)
{
  return (double)__cuda_tanf((float)a);
}

static double __cuda_exp(double a)
{
  return (double)__cuda_expf((float)a);
}

static double __cuda_exp2(double a)
{
  return (double)__cuda_exp2f((float)a);
}

static double __cuda_exp10(double a)
{
  return (double)__cuda_exp10f((float)a);
}

static double __cuda_expm1(double a)
{
  return (double)__cuda_expm1f((float)a);
}

static double __cuda_cosh(double a)
{
  return (double)__cuda_coshf((float)a);
}

static double __cuda_sinh(double a)
{
  return (double)__cuda_sinhf((float)a);
}

static double __cuda_tanh(double a)
{
  return (double)__cuda_tanhf((float)a);
}

static double __cuda_asin(double a)
{
  return (double)__cuda_asinf((float)a);
}

static double __cuda_acos(double a)
{
  return (double)__cuda_acosf((float)a);
}

static double __cuda_atan(double a)
{
  return (double)__cuda_atanf((float)a);
}

static double __cuda_atan2(double a, double b)
{
  return (double)__cuda_atan2f((float)a, (float)b);
}

static double __cuda_log(double a)
{
  return (double)__cuda_logf((float)a);
}

static double __cuda_log2(double a)
{
  return (double)__cuda_log2f((float)a);
}

static double __cuda_log10(double a)
{
  return (double)__cuda_log10f((float)a);
}

static double __cuda_log1p(double a)
{
  return (double)__cuda_log1pf((float)a);
}

static double __cuda_acosh(double a)
{
  return (double)__cuda_acoshf((float)a);
}

static double __cuda_asinh(double a)
{
  return (double)__cuda_asinhf((float)a);
}

static double __cuda_atanh(double a)
{
  return (double)__cuda_atanhf((float)a);
}

static double __cuda_hypot(double a, double b)
{
  return (double)__cuda_hypotf((float)a, (float)b);
}

static double __cuda_cbrt(double a)
{
  return (double)__cuda_cbrtf((float)a);
}

static double __cuda_erf(double a)
{
  return (double)__cuda_erff((float)a);
}

static double __cuda_erfc(double a)
{
  return (double)__cuda_erfcf((float)a);
}

static double __cuda_lgamma(double a)
{
  return (double)__cuda_lgammaf((float)a);
}

static double __cuda_tgamma(double a)
{
  return (double)__cuda_tgammaf((float)a);
}

static double __cuda_ldexp(double a, int b)
{
  return (double)__cuda_ldexpf((float)a, b);
}

static double __cuda_scalbn(double a, int b)
{
  return (double)__cuda_scalbnf((float)a, b);
}

static double __cuda_scalbln(double a, long b)
{
  return (double)__cuda_scalblnf((float)a, b);
}

static double __cuda_frexp(double a, int *b)
{
  return (double)__cuda_frexpf((float)a, b);
}

static double __cuda_modf(double a, double *b)
{
  float fb;
  float fa = __cuda_modff((float)a, &fb);

  *b = (double)fb;

  return (double)fa;  
}

static double __cuda_fmod(double a, double b)
{
  return (double)__cuda_fmodf((float)a, (float)b);
}

static double __cuda_remainder(double a, double b)
{
  return (double)__cuda_remainderf((float)a, (float)b);
}

static double __cuda_remquo(double a, double b, int *c)
{
  return (double)__cuda_remquof((float)a, (float)b, c);
}

static double __cuda_nextafter(double a, double b)
{
  return (double)__cuda_nextafterf((float)a, (float)b);
}

static double __cuda_nan(const char *tagp)
{
  return (double)__cuda_nanf(tagp);
}

static double __cuda_pow(double a, double b)
{
  return (double)__cuda_powf((float)a, (float)b);
}

static double __cuda_round(double a)
{
  return (double)__cuda_roundf((float)a);
}

static long __cuda_lround(double a)
{
  return __cuda_lroundf((float)a);
}

static long long __cuda_llround(double a)
{
  return __cuda_llroundf((float)a);
}

static double __cuda_rint(double a)
{
  return (double)__cuda_rintf((float)a);
}

static long __cuda_lrint(double a)
{
  return __cuda_lrintf((float)a);
}

static long long __cuda_llrint(double a)
{
  return __cuda_llrintf((float)a);
}

static double __cuda_nearbyint(double a)
{
  return (double)__cuda_nearbyintf((float)a);
}

static double __cuda_fdim(double a, double b)
{
  return (double)__cuda_fdimf((float)a, (float)b);
}

static int __cuda_ilogb(double a)
{
  return __cuda_ilogbf((float)a);
}

static double __cuda_logb(double a)
{
  return (double)__cuda_logbf((float)a);
}

static double __cuda_fma(double a, double b, double c)
{
  return (double)__cuda_fmaf((float)a, (float)b, (float)c);
}

#line 371 "c:\\cuda\\include\\math_functions_dbl_ptx1.h"

#line 373 "c:\\cuda\\include\\math_functions_dbl_ptx1.h"
#line 4168 "c:\\cuda\\include\\math_functions.h"

#line 4170 "c:\\cuda\\include\\math_functions.h"

#line 4172 "c:\\cuda\\include\\math_functions.h"

#line 89 "C:\\CUDA\\include\\common_functions.h"

#line 91 "C:\\CUDA\\include\\common_functions.h"

#line 20 "TEXF_MLA.cu"

#line 22 "TEXF_MLA.cu"

#line 24 "TEXF_MLA.cu"

#line 26 "TEXF_MLA.cu"
#line 1256 "c:\\cuda\\include\\texture_fetch_functions.h"
static __inline__ float _Z5tex2DIL19cudaTextureReadMode1EEf7textureIfLi2EXT_EEff(
#line 1256 "c:\\cuda\\include\\texture_fetch_functions.h"
__f2texture t, 
#line 1256 "c:\\cuda\\include\\texture_fetch_functions.h"
float x, 
#line 1256 "c:\\cuda\\include\\texture_fetch_functions.h"
float y)
#line 1257 "c:\\cuda\\include\\texture_fetch_functions.h"
{
#line 1257 "c:\\cuda\\include\\texture_fetch_functions.h"
auto float4 __T22;
#line 1258 "c:\\cuda\\include\\texture_fetch_functions.h"
auto float4 v;
#line 1258 "c:\\cuda\\include\\texture_fetch_functions.h"
v = (__ftexfetch2D(t, ((((((__T22.x) = x) , ((__T22.y) = y)) , ((__T22.z) = (0.0F))) , ((__T22.w) = (0.0F))) , __T22)));
#line 1260 "c:\\cuda\\include\\texture_fetch_functions.h"
return (v.x);
#line 1261 "c:\\cuda\\include\\texture_fetch_functions.h"
}
#line 20 "TEXF_MLA.cu"
__attribute__((__global__)) void _Z20delay_and_sum_kernelPf(
#line 20 "TEXF_MLA.cu"
__attribute__((__shared__)) float *const out_data){
#line 20 "TEXF_MLA.cu"
{
#line 21 "TEXF_MLA.cu"
{
#line 22 "TEXF_MLA.cu"
auto int idx;
#line 23 "TEXF_MLA.cu"
auto float i;
#line 24 "TEXF_MLA.cu"
auto int beam;
#line 22 "TEXF_MLA.cu"
idx = ((int)((((blockIdx.x)) * 384U) + ((threadIdx.x))));
#line 23 "TEXF_MLA.cu"
i = ((float)idx);
#line 24 "TEXF_MLA.cu"
beam = ((int)((blockIdx.y)));
#line 25 "TEXF_MLA.cu"
idx += (beam * 6144);
#line 25 "TEXF_MLA.cu"
{
#line 26 "TEXF_MLA.cu"
auto int mla;
#line 26 "TEXF_MLA.cu"
mla = 0;
#line 26 "TEXF_MLA.cu"
for (; (mla < 4); mla++)
#line 27 "TEXF_MLA.cu"
{
#line 28 "TEXF_MLA.cu"
auto float out;
#line 29 "TEXF_MLA.cu"
auto float y;
#line 30 "TEXF_MLA.cu"
auto float y_max;
#line 31 "TEXF_MLA.cu"
auto int n;
#line 28 "TEXF_MLA.cu"
out = (0.0F);
#line 29 "TEXF_MLA.cu"
y = ((0.5F) + ((float)(128 * beam)));
#line 30 "TEXF_MLA.cu"
y_max = ((float)(128 * (beam + 1)));
#line 31 "TEXF_MLA.cu"
n = 0;
#line 32 "TEXF_MLA.cu"
do
#line 32 "TEXF_MLA.cu"
{
#line 32 "TEXF_MLA.cu"
auto float __T24;
#line 33 "TEXF_MLA.cu"
out += (_Z5tex2DIL19cudaTextureReadMode1EEf7textureIfLi2EXT_EEff(tex, (((0.5F) + (fdividef(i, (2.0F)))) + ((__T24 = (((fdividef((i * i), (4.0F))) + (C1_gpu[n])) - ((i * (C3_gpu[n])) * (((float *)(C4_gpu + beam))[mla])))) , (__cuda_sqrtf(__T24)))), y));
#line 34 "TEXF_MLA.cu"
y += (1.0F);
#line 35 "TEXF_MLA.cu"
n += 1;
#line 36 "TEXF_MLA.cu"
} while (y < y_max);
#line 37 "TEXF_MLA.cu"
(out_data[idx]) = out;
#line 38 "TEXF_MLA.cu"
idx += 6144;
#line 39 "TEXF_MLA.cu"
}
#line 39 "TEXF_MLA.cu"
}
#line 40 "TEXF_MLA.cu"
} 
#line 40 "TEXF_MLA.cu"
}}


#line 44 "TEXF_MLA.cu"
