function [x y] = genPointsHei(depth)

global pointSpace

pointSpace = 1/100;


[x y] = makeline(       [0.5836 0.6031],[0.6094 0.5651]);
[nx ny] = makeline(       [0.6047 0.5992],[0.5571 0.5148]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.6641 0.6672],[0.8015 0.6644]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.6656 0.6867],[0.7285 0.7568]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.6859 0.7055],[0.7536 0.7295]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7031 0.6992],[0.7216 0.6655]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7289 0.7594],[0.7079 0.7146]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7547 0.743],[0.717 0.7306]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7414 0.7297],[0.7273 0.726]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7281 0.7266],[0.7205 0.6963]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7266 0.7391],[0.6931 0.6712]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7406 0.7625],[0.6737 0.6804]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7828 0.7859],[0.725 0.6758]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.7797 0.7852],[0.7456 0.7454]);
x = [x nx]; y = [y ny];



x = x*depth;
y = (y-0.5)*depth;

end

function [x y] = makeline(X, Y)
global pointSpace
    len = sqrt((X(1)-X(2))^2 + (Y(1)-Y(2))^2);
    x = linspace(X(1),X(2), round(len/pointSpace) );
    y = linspace(Y(1),Y(2), round(len/pointSpace) );
end