function [x y] = genPointsTest(depth)

global pointSpace

pointSpace = 1/40;

[x y] = makeline(       [0.2643 0.2982],[0.5109 0.4262]);
[nx ny] = makeline(       [0.3179 0.3804],[0.4085 0.3571]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.4143 0.5125],[0.3514 0.3333]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.5411 0.6304],[0.3466 0.4238]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.6304 0.6607],[0.4728 0.6881]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.6446 0.5357],[0.718 0.8286]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.2804 0.2589],[0.6405 0.5357]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.5036 0.4393],[0.8333 0.8095]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.4036 0.2929],[0.8 0.6643]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.4036 0.3964],[0.6752 0.6476]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.5429 0.5357],[0.6847 0.6524]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.3839 0.4571],[0.5061 0.4619]);
x = [x nx]; y = [y ny];
[nx ny] = makeline(       [0.5482 0.4696],[0.5085 0.4619]);
x = [x nx]; y = [y ny];

% [x y] = makeline( [0.3964 0.6821],[0.7276 0.3048]);
% [nx ny] = makeline([0.7094 0.8664],[0.3655 0.2915]);
% x = [x nx]; y = [y ny];
% 
% [x y] = makeline( [0.5911 0.4875],[0.7204 0.631] );
% [nx ny] = makeline([0.5411 0.5839],[0.6776 0.6381]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.6071 0.55],[0.6752 0.6]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.6518 0.5982],[0.6609 0.5952]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.6536 0.6875],[0.6585 0.6143]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.6273 0.6492],[0.628 0.6039]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.5984 0.6367],[0.5926 0.5422]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.6914 0.6344],[0.515 0.4795]);
% x = [x nx]; y = [y ny];
% [nx ny] = makeline([0.7172 0.7125],[0.539 0.54]);
% x = [x nx]; y = [y ny];

x = x*depth;
y = (y-0.5)*depth;

end

function [x y] = makeline(X, Y)
global pointSpace
    len = sqrt((X(1)-X(2))^2 + (Y(1)-Y(2))^2);
    x = linspace(X(1),X(2), round(len/pointSpace) );
    y = linspace(Y(1),Y(2), round(len/pointSpace) );
end