% launches two kernels, measures time between last warp in first kernel
% and first warp in second kernel.

no_blocks = 256;

timeBetween = zeros(no_blocks,1);

for blocks=1:no_blocks
    ct = clockTest(512,1,1,blocks,2); 
    timeBetween(blocks) = min(ct(end/2+1:end))-max(ct(1:end/2));
end

plot(1:no_blocks,timeBetween,'b')