reps = 10;
blocks = round(logspace(1,log10(10000),50));
threads = 16:16:512;
bw = zeros(50,length(threads));
bw2 = zeros(50,length(threads));
for i=1:length(threads)
    threads(i)
    bw(:,i) = bandwidthTestReadOnly(threads(i),blocks,reps);
end
%%
% Create figure
figure1 = figure('PaperSize',[20.98 29.68]);

% Create axes
axes1 = axes('Parent',figure1,'XTick',0:64:512);
view([-25 24]);
xlim([0 512]);
grid('on');
hold('all');

surf(threads,log10(blocks),bw/(1024*1024*1024))
zlabel('Transfer rate [GB/s]')
ylabel('10^x blocks in grid')
xlabel('Threads per block')
%%
% 
% figure
% [C,h] = contour(threads,log10(blocks),bw/(1024*1024*1024),0:10:80);
% zlabel('Transfer rate [GB/s]')
% ylabel('10^x blocks in grid')
% xlabel('Threads per block')
% set(h,'ShowText','on')